#include <Windows.h>
#include <sigscanner.h>
#include <string>
#include <vector>
#include <filesystem>
#include <algorithm>
#include <sstream>
#include <MinHook.h>

std::vector<std::string> terrains = {"-Beach", "-Desert", "-Farm", "-Forest", "-Hell", "Art", "Cheese", "Construction", "Desert", "Dungeon", "Easter", "Forest", "Fruit", "Gulf", "Hell", "Hospital", "Jungle", "Manhattan", "Medieval", "Music", "Pirate", "Snow", "Space", "Sports", "Tentacle", "Time", "Tools", "Tribal", "Urban"};
std::vector<std::string> customTerrains;
void scanDir(std::string path) {
	namespace fs = std::filesystem;
	for (const auto & entry : fs::recursive_directory_iterator(path)) {
		if(!entry.is_regular_file()) continue;
		auto filename = entry.path().filename().string();
		std::transform(filename.begin(), filename.end(), filename.begin(), [](unsigned char c){ return std::tolower(c);});
		if(filename == "level.dir") {
			auto dirname = entry.path().parent_path().filename().string();
			if(std::find(terrains.begin(), terrains.end(), dirname) == terrains.end()) {
				terrains.push_back(dirname);
				customTerrains.push_back(dirname);
			}
		}
	}
}

//lazy fix for cmp eax, 128 bug
int vectorSize;
int loopRet;
__declspec(naked) void loopFix() {
	_asm {
			MOV EAX, DWORD PTR SS : [ESP + 0x10]
			ADD EAX, 4
			PUSH ECX
			MOV ECX, vectorSize
			CMP EAX, ECX
			POP ECX
			MOV DWORD PTR SS : [ESP + 0x10], EAX
			JMP loopRet
	}
}

void (__fastcall *addrLobbySendGreentext)(const char * msg, void * EDX, void* This, int a3, int a4);
char * addrMyNickname;
int (__fastcall *origLobbyClientCommands)(void* This, void* EDX, char **commandstrptr, char **argstrptr);
int __fastcall hookLobbyClientCommands(void *This, void *EDX, char **commandstrptr, char **argstrptr) {
	std::string command = std::string(commandstrptr[0]);
	std::string args = std::string(argstrptr[0]);

	if(command == "terrains") {
		std::stringstream ss;
		ss << addrMyNickname << " is using wkTerrain38_v2: ";
		for(auto & it : customTerrains) {
			ss << it << "  ";
		}
		addrLobbySendGreentext(ss.str().c_str(), 0, This, 0, 0);
		return 1;
	}
	return origLobbyClientCommands(This, EDX, commandstrptr, argstrptr);
}

void hook(std::string name, DWORD pTarget, DWORD *pDetour, DWORD *ppOriginal) {
	if(!pTarget)
		throw std::runtime_error("Hook adress is null: " + name);
	if(MH_CreateHook((LPVOID)pTarget, (LPVOID)pDetour, (LPVOID*)ppOriginal) != MH_OK)
		throw std::runtime_error("Failed to create hook: " + name);
	if(MH_EnableHook((LPVOID)pTarget) != MH_OK)
		throw std::runtime_error("Failed to enable hook: " + name);
}


int patchList() {
	SignatureScanner SigScanner;
	SigScanner.GetProcess();
	module mod = SigScanner.GetModule();
	if(!mod.dwBase)
		throw std::runtime_error("Failed to initialize signature scanner");
	if (MH_Initialize() != MH_OK)
		throw std::runtime_error("Failed to initialize Minhook");

	DWORD addrTerrain4 = SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x55\x8B\xEC\x83\xE4\xF8\x64\xA1\x00\x00\x00\x00\x6A\xFF\x68\x00\x00\x00\x00\x50\x8B\x45\x0C\x64\x89\x25\x00\x00\x00\x00\x83\xEC\x20\x85\xC0\x53\x56\x57\x8B\xD9\x74\x63", "??????xx????xxx????xxxxxxx????xxxxxxxxxxxx"); //488A30
	DWORD addrTerrain4Limit = addrTerrain4 + 0x1B7;
	DWORD addrTerrain4List = addrTerrain4 + 0x204;

	DWORD addrTerrain3 =  SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x55\x8B\xEC\x83\xE4\xF8\x83\xEC\x0C\x8B\x45\x08\x53\x56\x05\x00\x00\x00\x00\x57\x89\x44\x24\x0C\xC7\x44\x24\x00\x00\x00\x00\x00\x68\x00\x00\x00\x00\xE8\x00\x00\x00\x00", "??????xxxxxxxxx????xxxxxxxx?????x????x????"); // 487760
	DWORD addrTerrain3Limit = addrTerrain3 + 0x138;
	DWORD addrTerrain3List = addrTerrain3 + 0x7C;
	DWORD addrTerrain3Loop = addrTerrain3 + 0x131;
	DWORD addrTerrain3LoopRet = addrTerrain3 + 0x13F;


	DWORD addrTerrain2Reference = SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x6A\xFF\x68\x00\x00\x00\x00\x64\xA1\x00\x00\x00\x00\x50\x64\x89\x25\x00\x00\x00\x00\x81\xEC\x00\x00\x00\x00\xA1\x00\x00\x00\x00\x8B\x0D\x00\x00\x00\x00\x8B\x15\x00\x00\x00\x00\x89\x84\x24\x00\x00\x00\x00", "???????xx????xxxx????xx????x????xx????xx????xxx????"); //449AD0
	DWORD addrTerrain2 = addrTerrain2Reference + 0xC10 + *(DWORD*)(addrTerrain2Reference + 0xC0C); //487610
	DWORD addrTerrain2List1 = addrTerrain2 + 0x1B;
	DWORD addrTerrain2List2 = addrTerrain2 + 0xF6;

	DWORD addrTerrain1 = SigScanner.FindSignature(mod.dwBase, mod.dwSize,  "\x64\xA1\x00\x00\x00\x00\x6A\xFF\x68\x00\x00\x00\x00\x50\x64\x89\x25\x00\x00\x00\x00\x83\xEC\x08\x56\x8B\xF1\x8B\x04\xB5\x00\x00\x00\x00\x80\x38\x2B\x57\x75\x1F", "??????xxx????xxxx????xxxxxxxxx????xxxxxx"); // 4874D0

	DWORD addrTerrain1List1 = addrTerrain1 + 0x1B;
	DWORD addrTerrain1List2 = addrTerrain1 + 0xEB;

	DWORD addrTerrain0 =  SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x55\x8B\xEC\x83\xE4\xF8\x6A\xFF\x68\x00\x00\x00\x00\x64\xA1\x00\x00\x00\x00\x50\x64\x89\x25\x00\x00\x00\x00\x51\xB8\x00\x00\x00\x00\xE8\x00\x00\x00\x00\x53\x8B\x5D\x08\x56", "??????xxx????xx????xxxx????xx????x????xxxxx"); //44A910
	DWORD addrTerrain0Limit = addrTerrain0 + 0x851;

	DWORD addrLobbyClientCommands = SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x55\x8B\xEC\x83\xE4\xF8\x6A\xFF\x68\x00\x00\x00\x00\x64\xA1\x00\x00\x00\x00\x50\x64\x89\x25\x00\x00\x00\x00\x83\xEC\x40\x53\x56\x8B\x75\x08\x8B\x06\x57\x8B\xD9\x68\x00\x00\x00\x00\x50\x89\x5C\x24\x1C\xE8\x00\x00\x00\x00\x83\xC4\x08\x85\xC0", "??????xxx????xx????xxxx????xxxxxxxxxxxxxx????xxxxxx????xxxxx"); //4AAAA0
	addrLobbySendGreentext =
			(void (__fastcall *)(const char*,void *,void *,int, int))
					SigScanner.FindSignature(mod.dwBase, mod.dwSize, "\x6A\xFF\x68\x00\x00\x00\x00\x64\xA1\x00\x00\x00\x00\x50\x64\x89\x25\x00\x00\x00\x00\x51\x56\x57\x8B\xF1\x68\x00\x00\x00\x00\x8D\x4C\x24\x0C\xE8\x00\x00\x00\x00\x80\x7C\x24\x00\x00", "???????xx????xxxx????xxxxxx????xxxxx????xxx??"); //4AA870
	addrMyNickname = *(char**)((DWORD)addrLobbySendGreentext + 0x4D);

	hook("LobbyClientCommands", addrLobbyClientCommands, (DWORD*)&hookLobbyClientCommands, (DWORD*)&origLobbyClientCommands);


	//copy vector to char array
	char ** terrainList = (char**)calloc(terrains.size() + 1, sizeof(char*));
	vectorSize = terrains.size()*4;
	int i;
	for (i = 0; i < terrains.size(); ++i) {
		terrainList[i] = (char*)terrains[i].c_str();
	}
	terrainList[i] = 0;

	int t_off = (int)terrainList;
	unsigned char limit = terrains.size();

#define PATCH_OP(op, off, num) op[num+3] = (char) ((off & 0xFF000000) >> 24 ); op[num+2] = (char) ((off & 0x00FF0000) >> 16 ) ; op[num+1] = (char) ((off & 0x0000FF00) >> 8 ); op[num] = (char) ((off & 0x000000FF)      );

	HANDLE handle = GetCurrentProcess();
	SIZE_T numwritten;

	//terrain 4
	unsigned char terrain4Limit_op[] = { 0x83, 0xFE, 0x1d }; // cmp esi, 0x1D
	terrain4Limit_op[2] = limit;
	WriteProcessMemory(handle, (LPVOID)addrTerrain4Limit, terrain4Limit_op, sizeof(terrain4Limit_op), &numwritten);

	unsigned char terrain4List_op[] = { 0x8B, 0x0C, 0xB5, 0x68, 0xB5, 0x67, 0x00 }; //MOV ECX,DWORD PTR DS:[ESI*4+67B568]
	PATCH_OP(terrain4List_op, t_off, 3);
	WriteProcessMemory(handle, (LPVOID)addrTerrain4List, terrain4List_op, sizeof(terrain4List_op), &numwritten);

	////////////////////////////////////

	//terrain 3
	//char terrain3Limit_op[] = { 0x83, 0xF8, 0x7C }; // CMP EAX,7C
	//terrain3Limit_op[2] = (limit-1) * 4;
	//WriteProcessMemory(handle, getOffset("terrain3Limit"), terrain3Limit_op, sizeof(terrain3Limit_op), &numwritten);

	int code_off = (int)loopFix;
	loopRet = addrTerrain3LoopRet;
	unsigned char jump_op[] = { 0x68, 0x00, 0x00, 0x00, 0x00, 0xc3, 0x90 }; // PUSH OFFSET ... RETN
	PATCH_OP(jump_op, code_off, 1);
	WriteProcessMemory(handle, (LPVOID)addrTerrain3Loop, jump_op, sizeof(jump_op), &numwritten);

	unsigned char terrain3List_op[] = { 0x8B, 0x81, 0x68, 0xB5, 0x67, 0x00 }; //MOV EAX,DWORD PTR DS:[ECX+67B568]
	PATCH_OP(terrain3List_op, t_off, 2);
	WriteProcessMemory(handle, (LPVOID)addrTerrain3List, terrain3List_op, sizeof(terrain3List_op), &numwritten);


	///////////////////////////////////////
	//terrain2

	unsigned char terrain2List1_op[] = { 0x8B, 0x04, 0xB5, 0x68, 0xB5, 0x67, 0x00 }; //MOV EAX,DWORD PTR DS:[ESI*4+67B568]
	PATCH_OP(terrain2List1_op, t_off, 3);
	WriteProcessMemory(handle, (LPVOID)addrTerrain2List1, terrain2List1_op, sizeof(terrain2List1_op), &numwritten);

	unsigned char terrain2List2_op[] = { 0x8B, 0x04, 0xB5, 0x68, 0xB5, 0x67, 0x00 }; //MOV EAX,DWORD PTR DS:[ESI*4+67B568]
	PATCH_OP(terrain2List2_op, t_off, 3);
	WriteProcessMemory(handle, (LPVOID)addrTerrain2List2, terrain2List2_op, sizeof(terrain2List2_op), &numwritten);

	/////////////////////////////////////////
	//terrain1

	unsigned char terrain1List1_op[] = { 0x8B, 0x04, 0xB5, 0x68, 0xB5, 0x67, 0x00 }; //MOV EAX,DWORD PTR DS:[ESI*4+67B568]
	PATCH_OP(terrain1List1_op, t_off, 3);
	WriteProcessMemory(handle, (LPVOID)addrTerrain1List1, terrain1List1_op, sizeof(terrain1List1_op), &numwritten);

	unsigned char terrain1List2_op[] = { 0x8B, 0x04, 0xB5, 0x68, 0xB5, 0x67, 0x00 }; //MOV EAX,DWORD PTR DS:[ESI*4+67B568]
	PATCH_OP(terrain1List2_op, t_off, 3);
	WriteProcessMemory(handle, (LPVOID)addrTerrain1List2, terrain1List2_op, sizeof(terrain1List2_op), &numwritten);

	////terrain1d
	unsigned char terrain1dLimit_op[] = { 0x83, 0xBB, 0x18, 0x05, 0x00, 0x00, 0x1d}; //CMP DWORD PTR DS:[EBX+518],1D
	terrain1dLimit_op[6] = limit;
	WriteProcessMemory(handle, (LPVOID)addrTerrain0Limit, terrain1dLimit_op, sizeof(terrain1dLimit_op), &numwritten);
	return 0;
}

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved) {
	switch(ul_reason_for_call) {
		case DLL_PROCESS_ATTACH:
			try {
				scanDir("Data/Level/");
				patchList();
			} catch(std::exception & e) {
				MessageBoxA(0, e.what(), "wkTerrain38_v2", MB_ICONERROR);
			}
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
		default:
			break;
	}
	return TRUE;
}
